.386
.model flat,stdcall
option casemap:none
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
LoadBmp proto :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib

.const

MAXSIZE equ 260



.data
ClassName		 db "BmpView",0
AppName 		 db "Viewer",0
MenuName 		 db "FirstMenu",0
ofn  			 OPENFILENAME <>
FilterString 		 db "bmp files",0,"*.bmp",0,0
buffer 			 db MAXSIZE dup(0)
OurTitle 		 db "Open BMP file",0
Crt			 db 0dh,0
msgtitle		 db 'bmp viewer',0
bmpok			 db "it's a bmp file",0
uncom			 db 'uncompresssed',0
depth			 db 'color depth 24',0
fmt			 db "width: %x height: %x size: %x",0


heapsuc2		 db 'heap reallocated succeed',0


width1             	 dd 1
height1            	 dd 2
size1              	 dd 3
.data?
hInstance 		       HINSTANCE ?
CommandLine 		       LPSTR ?
hBmp			       dd ?
hMemDC			       dd ?
hWndDC			       dd ?
bmpheader		       BITMAPFILEHEADER <>
bmpinfo			       BITMAPINFOHEADER <>
hWND			       dd ?

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,479,359,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
		INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL bm :BITMAP
	
	LOCAL buffer1[512]:BYTE
	push hWnd
	pop hWND
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL

	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==1
			mov ofn.lStructSize,SIZEOF ofn
			push hWnd
			pop  ofn.hWndOwner
			push hInstance
			pop  ofn.hInstance
			mov  ofn.lpstrFilter, OFFSET FilterString
			mov  ofn.lpstrFile, OFFSET buffer
			mov  ofn.nMaxFile,MAXSIZE
			mov  ofn.Flags, OFN_FILEMUSTEXIST or \
                        OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
                        OFN_EXPLORER or OFN_HIDEREADONLY
			mov  ofn.lpstrTitle, OFFSET OurTitle
			invoke GetOpenFileName, ADDR ofn
			.if eax==TRUE
				invoke LoadImage,0,ofn.lpstrFile,IMAGE_BITMAP,0,0,LR_LOADFROMFILE
				mov hBmp,eax
				invoke LoadBmp,addr width1,addr height1,addr size1,ofn.lpstrFile
				invoke wsprintf,addr buffer1,addr fmt,width1,height1,size1
                       	        invoke MessageBox,0,addr buffer1,addr msgtitle,MB_OK
				invoke CreateCompatibleDC,0
				mov hMemDC,eax
				invoke SelectObject,eax,hBmp
				invoke GetObject,hBmp,sizeof bm,addr bm
				invoke GetDC,hWnd
				mov hWndDC,eax
				invoke BitBlt,eax,0,0,bm.bmWidth,bm.bmHeight,hMemDC,0,0,SRCCOPY
				invoke DeleteDC,hMemDC
				invoke ReleaseDC,hWnd,hWndDC
				
			.endif
		.else
			invoke DestroyWindow, hWnd
		.endif
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp

LoadBmp proc pwidth,pheight,psize,pszfile
	Local hFile:DWORD
	Local rdbytes:DWORD
        Local hHeap:DWORD
	Local pHeap:DWORD
	Local pHeap2:DWORD
	Local buffer2[512]:BYTE
	Local spw:DWORD
	Local rect : RECT 
	Local hDC:DWORD
	Local bmpWidth:DWORD
	Local bmpHeight:DWORD	

	invoke GetProcessHeap
	mov hHeap,eax
	invoke CreateFile,pszfile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,0
	mov hFile,eax
	invoke ReadFile,hFile,addr bmpheader,sizeof bmpheader,addr rdbytes,0
	invoke ReadFile,hFile,addr bmpinfo,sizeof bmpinfo,addr rdbytes,0
	;.if bmpheader.bfType == 'MB'
	;	invoke MessageBox,0,addr bmpok,addr msgtitle,MB_OK	
	;.endif
	;.if bmpinfo.biCompression == BI_RGB
	;	invoke MessageBox,0,addr uncom,addr msgtitle,MB_OK
	;.endif
	;.if bmpinfo.biBitCount == 24
	;	invoke MessageBox,0,addr depth,addr msgtitle,MB_OK
	;.endif

;--------calculate the spw-----------
	mov edx,bmpinfo.biHeight
	mov bmpHeight,edx
	mov ebx,bmpinfo.biWidth
	push ebx
	mov eax,ebx
	mov ebx,0
	mov ecx,3
	mul ecx
	add ebx,eax    
	add ebx,edx
	mov bmpWidth,ebx	;stores it to bmpWidth
	mov ecx,4
	div ecx
	mov eax,4
	sub eax,edx
	.if eax == 4
		mov eax,0
	.endif
	add eax,ebx
	mov spw,eax	;stores it to spw
	pop ebx
	
;------------------------------------




;--------return the value------------

	mov eax,pwidth
        mov [eax],ebx
     	mov ebx,bmpinfo.biHeight
        mov eax,pheight
	mov [eax],ebx
	mov ebx,bmpheader.bfSize
        sub ebx,bmpheader.bfOffBits
	mov eax,psize
	mov [eax],ebx

;------------------------------------

	invoke GetClientRect,hWND,addr rect
	sub rect.right,1
	sub rect.bottom,1
	invoke GetDC,hWND
	mov hDC,eax

	mov ecx,bmpHeight
	.while ecx > 0
		push ecx

;--------allocate heap---------------
		mov eax,bmpWidth
		mov ebx,spw
		add eax,ebx
		inc eax
		invoke HeapAlloc,hHeap,8,eax
		mov pHeap,eax
		add eax,ebx
		mov pHeap2,eax
;------------------------------------

		invoke ReadFile,hFile,pHeap,ebx,addr rdbytes,0
	
		mov esi,pHeap
		mov edi,pHeap2
	
	
	
		add esi,bmpWidth
		dec esi
		mov ecx,bmpWidth
		.while ecx > 0

			mov al,[esi]
			mov [edi],al
			dec esi
			inc edi
			dec ecx

		.endw
	

	


	

	
		mov esi,pHeap2
		mov edi,bmpWidth

	
		.while edi > 0
		
			mov eax,[esi]
			and eax,0FFFFFFh
			invoke CreatePen,PS_SOLID,1,eax
			invoke SelectObject,hDC,eax
			.if edi == bmpWidth
				push eax
			.else
				invoke DeleteObject,eax
			.endif
			invoke MoveToEx,hDC,rect.left,rect.top,0
			inc rect.left
			invoke LineTo,hDC,rect.left,rect.top
			add esi,3
			sub edi,3
	
		.endw
		pop eax
		invoke SelectObject,hDC,eax
		invoke DeleteObject,eax
		invoke HeapFree,hHeap,0,pHeap
		mov rect.left,0
		inc rect.top
		pop ecx
		dec ecx
	.endw
	invoke Sleep,3000
	ret
LoadBmp endp


end start
